# Contributing to build2docker development

:sparkles: Thank you for thinking about contributing to build2docker! :sparkles:

(And thank you particularly for coming to read the guidelines! :heart_eyes:)

The build2docker developer documentation is all rendered on our documentation website: [https://build2docker.readthedocs.io](https://build2docker.readthedocs.io).
If you're here, you're probably looking for the [Contributing to build2docker development](https://build2docker.readthedocs.io/en/latest/contributing/contributing.html) page.

Please make sure you've read the following sections before opening an issue/pull request:

- [Process for making a contribution](https://build2docker.readthedocs.io/en/latest/contributing/contributing.html#process-for-making-a-contribution).
  - These steps talk you through choosing the right issue template (bug report or feature request) and making a change.
- [Guidelines to getting a Pull Request merged](https://build2docker.readthedocs.io/en/latest/contributing/contributing.html#guidelines-to-getting-a-pull-request-merged).
  - These are tips and tricks to help make your contribution as smooth as possible for you and for the build2docker maintenance team.

There are a few other pages to highlight:

- [Our roadmap](https://build2docker.readthedocs.io/en/latest/contributing/roadmap.html)
  - We use the roadmap to develop a shared understanding of the project's vision and direction amongst the community of users, contributors, and maintainers.
    This is a great place to get a feel for what the maintainers are thinking about for the short, medium, and long term future of the project.
- [Design of build2docker](https://build2docker.readthedocs.io/en/latest/design.html)
  - This page explains some of the design principles behind build2docker.
    Its a good place to understand _why_ the team have made the decisions that they have along the way!
  - We absolutely encourage discussion around refactoring, updating or extending build2docker, but please make sure that you've understood this page before opening an issue to discuss the change you'd like to propose.
- [Common developer tasks and how-tos](https://build2docker.readthedocs.io/en/latest/contributing/tasks.html)
  - Some notes on running tests, buildpack dependencies, creating a release, and keeping the pip files up to date.
